"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Config_1 = require("../Config");
const TextDocGenerator_1 = require("./TextDocGenerator");
var DocGeneratorFactory;
(function (DocGeneratorFactory) {
    function create(format) {
        switch (format) {
            case Config_1.DocFormat.Text:
                return new TextDocGenerator_1.TextDocGenerator();
            default:
                throw new Error(`unhandled format!`);
        }
    }
    DocGeneratorFactory.create = create;
})(DocGeneratorFactory = exports.DocGeneratorFactory || (exports.DocGeneratorFactory = {}));
//# sourceMappingURL=DocGeneratorFactory.js.map