"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SPACES_PER_TAB = 2;
class ConsoleOutputter {
    constructor() {
        this.indent = 0;
    }
    decreaseIndent() {
        this.indent--;
        if (this.indent < 0) {
            throw new Error("indent would be negative!");
        }
    }
    increaseIndent() {
        this.indent++;
    }
    outputLine(text) {
        const indexText = " ".repeat(this.indent * SPACES_PER_TAB);
        console.log(`${indexText}${text}`);
    }
}
exports.ConsoleOutputter = ConsoleOutputter;
//# sourceMappingURL=ConsoleOutputter.js.map