"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Lint = require("tslint");
const GeneralRuleUtils_1 = require("./utils/GeneralRuleUtils");
const RULE_ID = "tslint-folders-test-with-breakpoint";
class Rule extends Lint.Rules.AbstractRule {
    apply(sourceFile) {
        if (!GeneralRuleUtils_1.GeneralRuleUtils.isInTestFile(sourceFile.fileName)) {
            return [];
        }
        const walker = new StatementsWalker(sourceFile, this.getOptions());
        this.applyWithWalker(walker);
        return walker.getFailures();
    }
}
exports.Rule = Rule;
class StatementsWalker extends Lint.RuleWalker {
    visitCallExpression(node) {
        const text = node.getText();
        if (text.startsWith("browser.debug")) {
            this.addFailureAtNode(node.getFirstToken(), GeneralRuleUtils_1.GeneralRuleUtils.buildFailureString("do not hard code breakpoints in the test", RULE_ID));
        }
        super.visitCallExpression(node);
    }
}
//# sourceMappingURL=tsLintFoldersTestWithBreakpointRule.js.map